using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Stub_callback
    {
        public delegate void on_return_ft(IntPtr _callback_, UInt32 _msg_num, Address _proxy_addr, Int32 _err, IntPtr _ret_dat_, UInt32 _ret_size, Double _elapsed);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_, on_return_ft _on_return_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_free")]
        public static extern void free(IntPtr _callback_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_delegate_callback")]
        public static extern Int32 delegate_callback(IntPtr _callback_, ref UInt32 _msg_num_, Address _proxy_addr, IntPtr _cbg_dat_, UInt32 _cbg_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_async_callback")]
        public static extern IntPtr async_callback(IntPtr _callback_, Address _proxy_addr, IntPtr _cbg_dat_, UInt32 _cbg_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_await_return")]
        public static extern Int32 await_return(IntPtr _callback_, IntPtr _promise_, IntPtr _ret_dat_, ref UInt32 _ret_size_, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_callback_cancel")]
        public static extern void cancel(IntPtr _callback_, Address _proxy_addr, Int32 _err);
    }
}
