using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Stub_signalback
    {
        public delegate void on_return_ft(IntPtr _signalback_, UInt32 _msg_num, Address _proxy_addr, Int32 _err, Double _elapsed);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_, on_return_ft on_return_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_free")]
        public static extern void free(IntPtr _signalback_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_delegate_signalback")]
        public static extern Int32 delegate_signalback(IntPtr _signalback_, ref UInt32 _msg_num_, Address _proxy_addr, IntPtr _sig_data_, UInt32 _sig_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_async_signalback")]
        public static extern IntPtr async_signalback(IntPtr _signalback_, Address _proxy_addr, IntPtr _sig_data_, UInt32 _sig_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_await_return")]
        public static extern Int32 await_return(IntPtr _signalback_, IntPtr _promise_, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_signalback")]
        public static extern Int32 signalback(IntPtr _signalback_, Address _proxy_addr, IntPtr _sig_data_, UInt32 _sig_size, Double _limit, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signalback_cancel")]
        public static extern void cancel(IntPtr _signalback_, Address _proxy_addr, Int32 _err);
    }
}
