<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable><xsl:text/>
# Copyright 2020. (주)웨어그램 all rights reserved.
# 빌드 CMakeLists.txt

cmake_minimum_required(VERSION 3.0.0)

project(<xsl:value-of select="$component_name"/> VERSION 0.1.0 LANGUAGES CSharp )

include(CSharpUtilities)

SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/bin")
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/bin")
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/bin")

file(GLOB_RECURSE C_FILES_SRC "${CMAKE_SOURCE_DIR}/src/*.cs")

add_executable(${PROJECT_NAME} ${C_FILES_SRC})

# App.config Properties/AssemblyInfo.cs

<!-- LIST(APPEND VS_DOTNET_REFERENCES "Microsoft.CSharp") -->
<!-- LIST(APPEND VS_DOTNET_REFERENCES "PresentationCore") -->
<!-- LIST(APPEND VS_DOTNET_REFERENCES "PresentationFramework") -->
LIST(APPEND VS_DOTNET_REFERENCES "System")
<!-- LIST(APPEND VS_DOTNET_REFERENCES "System.Xaml") -->
<!-- LIST(APPEND VS_DOTNET_REFERENCES "System.Xml") -->
<!-- LIST(APPEND VS_DOTNET_REFERENCES "System.Xml.Linq") -->
<!-- LIST(APPEND VS_DOTNET_REFERENCES "WindowsBase") -->

set_property(TARGET ${PROJECT_NAME} PROPERTY VS_DOTNET_REFERENCES "${VS_DOTNET_REFERENCES}")
set_property(TARGET ${PROJECT_NAME} PROPERTY VS_DOTNET_TARGET_FRAMEWORK_VERSION "v4.6.1")
target_compile_options(${PROJECT_NAME} PUBLIC "/unsafe")


</xsl:template>
</xsl:stylesheet>