#pragma once

#include <string>


inline std::string directory(std::string& _in)
{
    size_t find_name_1 = _in.rfind("\\") + 1;
    size_t find_name_2 = _in.rfind("/") + 1;
    size_t find_name = find_name_1 > find_name_2 ? find_name_1 : find_name_2;
    return _in.substr(0, find_name);
}

inline std::string filename(std::string& _in)
{
    size_t find_name_1 = _in.rfind("\\") + 1;
    size_t find_name_2 = _in.rfind("/") + 1;
    size_t find_name = find_name_1 > find_name_2 ? find_name_1 : find_name_2;
    return _in.substr(find_name, _in.length() - find_name);
}

inline std::string extname(std::string& _in)
{
    size_t find_ext = _in.rfind(".") + 1;
    return _in.substr(find_ext, _in.length() - find_ext);
}
