<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:include href="../../xsl_util.xsl"/>
<xsl:template match="/">



```plantuml
@startuml
left to right direction

<xsl:for-each select="/nerv_system_interface/system/nodes/node">
node "<xsl:value-of select="name"/>" {
	<xsl:for-each select="processes/process">
	component "<xsl:value-of select="../../name"/>::\n<xsl:value-of select="name"/>"
	</xsl:for-each>
}
</xsl:for-each>

<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub">
interface <xsl:value-of select="name"/><xsl:text>
</xsl:text>
[<xsl:value-of select="../../../../name"/>::\n<xsl:value-of select="../../name"/>] -[bold]- <xsl:value-of select="name"/><xsl:text>
</xsl:text>
</xsl:for-each>

<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy">
<xsl:value-of select="name"/> &lt;-- [<xsl:value-of select="../../../../name"/>::\n<xsl:value-of select="../../name"/>]
</xsl:for-each>


@enduml
```


</xsl:template>
</xsl:stylesheet>