#pragma once

#include "Stub.hh"

namespace Nerv36 {

class NERV_SDK_DLL Stub_datagram : virtual public Stub {
    friend class _Stub_datagram;

public:
    Stub_datagram(Msg_code _code);
    Stub_datagram(Msg_code _code, const Stub& _stub_);
    virtual ~Stub_datagram(void);
    Error broadcast(const void* _data_, Pksize _size);
    Error cast(IP _ip, const void* _data_, Pksize _size);

private:
    _Stub_datagram* _mp;
};

} // namespace Nerv36
