﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Proxy_call
    {
        public delegate void on_return_ft(IntPtr _call_, UInt32 _msg_num, Int32 _err, IntPtr _ret_dat_, UInt32 _ret_size, Double _elapsed);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_, on_return_ft _on_return_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_free")]
        public static extern void free(IntPtr _call_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_delegate_call")]
        public static extern Int32 delegate_call(IntPtr _call_, ref UInt32 _msg_num_, IntPtr _cal_dat_, UInt32 _cal_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_async_call")]
        public static extern IntPtr async_call(IntPtr _call_, IntPtr _cal_dat_, UInt32 _cal_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_await_return")]
        public static extern Int32 await_return(IntPtr _call_, IntPtr _promise_, IntPtr _ret_dat_, ref UInt32 _ret_size_, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_cancel")]
        public static extern void cancel(IntPtr _call_, Int32 _err);
    }
}
