﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Stub_signal
    {
        // nerv_stub_signal delegate
        public delegate void on_signal_ft(IntPtr _signal_, Address _proxy_addr, IntPtr _sig_data_, UInt32 _sig_size, Double _elapsed);

        public delegate void on_cancel_ft(IntPtr _signal_, Address _proxy_addr, Int32 _err);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signal_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object, on_signal_ft _on_signal_, on_cancel_ft _on_cancel_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_signal_free")]
        public static extern void free(IntPtr _signal_);
    }
}
