
#pragma once

#ifdef _MSC_VER
#include <winsock2.h>


#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

struct wg_code_page {
	UINT input;
	UINT output;
};

static struct wg_code_page begin_utf8()
{
	struct wg_code_page ret = {GetConsoleCP(), GetConsoleOutputCP()};

	SetConsoleCP(65001);       // 입력 코드페이지
	SetConsoleOutputCP(65001); // 출력 코드페이지
	return ret;
}

static void end_utf8(struct wg_code_page old)
{
	SetConsoleCP(old.input);
	SetConsoleOutputCP(old.output);
}

#ifdef __cplusplus
} // extern "C" {
#endif // __cplusplus

#else


#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

struct wg_code_page {};

static struct wg_code_page begin_utf8()
{
	return wg_code_page();
}

static void end_utf8(struct wg_code_page old)
{
}

#ifdef __cplusplus
} // extern "C" {
#endif // __cplusplus

#endif





