<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>

<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#!/bin/bash
echo "공통 환경의 빌드 전 작업을 수행합니다."

bash ./import/<xsl:value-of select="$component_name"/>/.script/_b clean build
cp -r ./import/<xsl:value-of select="$component_name"/>/devel/include/<xsl:value-of select="$component_name"/>/* ./import/<xsl:value-of select="$component_name"/>/.

# ./import/<xsl:value-of select="$component_name"/>/.script/_b clean
# rm -rf ./import/<xsl:value-of select="$component_name"/>/.script
# rm -rf ./import/<xsl:value-of select="$component_name"/>/data

</xsl:template>
</xsl:stylesheet>
